;
;********************************************************************
;               D-A-Converter
;This DA-converter drives serial DAC chips as e.g. MAXIM MAX543
;(12bit, current out) or MAX547 (12bit, voltage out)
;
;The routine outputs the lower nibble of out_h as the 4 MSBits and
;out_l as LSByte = 12bits.
;It require         2 byte RAM
;                   3 port pins (SRI, LD, CLK) out of e.g. Port_B
;                  88 byte program memory
;                  40 us at 8mc xtal frequency
;
;the routine is run time optimized (no loops)
;use it if you like it
;sorry I did not write a code optimized one but you might do that
;and send me a copy also (I am suffering a chronical lack of time...)
;
;*********************************************************************
; declare the Portbits CLK, SRI, LD and the files out_h and out_l
;*********************************************************************

anout   BCF     Port_B, SRI     ;initial state: SRI=0, LD=1, CLK=0
        BSF     Port_B, LD
        BCF     Port_B, CLK
        BTFSS   out_h, 3        ;test MSB and
        GOTO    anout3
        BSF     Port_B, SRI
        GOTO    anout4
anout3  BCF     Port_B, SRI     ;adjust SRI according to MSB level
anout4  BSF     Port_B, CLK     ;clock CLK once
        BCF     Port_B, CLK
        BTFSS   out_h, 2        ;test next bit......
        GOTO    anout5
        BSF     Port_B, SRI
        GOTO    anout6
anout5  BCF     Port_B, SRI
anout6  BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_h, 1
        GOTO    anout7
        BSF     Port_B, SRI
        GOTO    anout8
anout7  BCF     Port_B, SRI
anout8  BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_h, 0
        GOTO    anout9
        BSF     Port_B, SRI
        GOTO    anout10
anout9  BCF     Port_B, SRI
anout10 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 7
        GOTO    anout11
        BSF     Port_B, SRI
        GOTO    anout12
anout11 BCF     Port_B, SRI
anout12 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 6
        GOTO    anout13
        BSF     Port_B, SRI
        GOTO    anout14
anout13 BCF     Port_B, SRI
anout14 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 5
        GOTO    anout15
        BSF     Port_B, SRI
        GOTO    anout16
anout15 BCF     Port_B, SRI
anout16 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 4
        GOTO    anout17
        BSF     Port_B, SRI
        GOTO    anout18
anout17 BCF     Port_B, SRI
anout18 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 3
        GOTO    anout19
        BSF     Port_B, SRI
        GOTO    anout20
anout19 BCF     Port_B, SRI
anout20 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 2
        GOTO    anout21
        BSF     Port_B, SRI
        GOTO    anout22
anout21 BCF     Port_B, SRI
anout22 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 1
        GOTO    anout23
        BSF     Port_B, SRI
        GOTO    anout24
anout23 BCF     Port_B, SRI
anout24 BSF     Port_B, CLK
        BCF     Port_B, CLK
        BTFSS   out_l, 0        ;read last bit
        GOTO    anout25
        BSF     Port_B, SRI
        GOTO    anout26
anout25 BCF     Port_B, SRI
anout26 BSF     Port_B, CLK     ;last clock 0-to-1 transition
        BCF     Port_B, LD      ;to declare last bit, LD toggles before
        BCF     Port_B, CLK     ;last clock 1-to-0 transition an
        BSF     Port_B, LD      ;restores LD=1 finally

